SlotMap (rhino 1.7.14 API)

org.mozilla.javascript

## Interface SlotMap

- All Superinterfaces:
    java.lang.Iterable<Slot>
  All Known Implementing Classes:
    EmbeddedSlotMap, HashSlotMap

      public interface SlotMap
      extends java.lang.Iterable<Slot>

  A SlotMap is an interface to the main data structure that contains all the "Slots" that back a ScriptableObject. It is the primary property map in Rhino. It is Iterable but does not implement java.util.Map because that comes with a bunch of overhead that we do not need.

  This class generally has a bit of a strange interface, and its interactions with ScriptableObject are complex. Many attempts to make this interface more elegant have resulted in substantial performance regressions so we are doing the best that we can.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(Slot newSlot)` Insert a new slot to the map.
    `boolean` | `isEmpty()` Return whether the map is empty.
    `Slot` | `modify(java.lang.Object key, int index, int attributes)` Return the Slot that matches EITHER "key" or "index".
    `Slot` | `query(java.lang.Object key, int index)` Retrieve the slot at EITHER key or index, or return null if the slot cannot be found.
    `void` | `remove(java.lang.Object key, int index)` Remove the slot at either "key" or "index".
    `void` | `replace(Slot oldSlot, Slot newSlot)` Replace "slot" with a new slot.
    `int` | `size()` Return the size of the map.

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, iterator, spliterator`

- - ### Method Detail

    - #### size

          int size()

      Return the size of the map.

    - #### isEmpty

          boolean isEmpty()

      Return whether the map is empty.

    - #### modify

          Slot modify(java.lang.Object key,
                      int index,
                      int attributes)

      Return the Slot that matches EITHER "key" or "index". (It will use "key" if it is not null, and otherwise "index".) If no slot exists, then create a default slot class.
      Parameters:
        `key` - The key for the slot, which should be a String or a Symbol.
        `index` - if key is zero, then this will be used as the key instead.
        `attributes` - the attributes to be set on the slot if a new slot is created. Existing slots will not be modified.
      Returns:
        a Slot, which will be created anew if no such slot exists.

    - #### query

          Slot query(java.lang.Object key,
                     int index)

      Retrieve the slot at EITHER key or index, or return null if the slot cannot be found.
      Parameters:
        `key` - The key for the slot, which should be a String or a Symbol.
        `index` - if key is zero, then this will be used as the key instead.
      Returns:
        either the Slot that matched the key and index, or null

    - #### replace

          void replace(Slot oldSlot,
                       Slot newSlot)

      Replace "slot" with a new slot. This is used to change slot types.

    - #### add

          void add(Slot newSlot)

      Insert a new slot to the map. Both "name" and "indexOrHash" must be populated. Note that ScriptableObject generally adds slots via the "modify" method.

    - #### remove

          void remove(java.lang.Object key,
                      int index)

      Remove the slot at either "key" or "index".
      Parameters:
        `key` - The key for the slot, which should be a String or a Symbol.
        `index` - if key is zero, then this will be used as the key instead.